from urllib   import urlopen
from urlparse import urljoin
from HTMLParser import HTMLParser, HTMLParseError

import sys


class LinkExtractor(HTMLParser):

    def __init__(self):
        HTMLParser.__init__(self)
        self.links = []

    def handle_starttag(self, tag, attrs):
        if tag.lower() == 'a':
            for (key, val) in attrs:
                if key.lower() == "href":
                    self.links.append(val)

def extract_links(url):
    f = urlopen(url)
    if f.getcode() == 200: # HTTP code 200 means OK
        ex = LinkExtractor()
        ex.feed(f.read())
        return ex.links
    else:
        raise IOError, "HTTP: %d" % f.getcode()

def check_link(url, link):
    try:
        f = urlopen(urljoin(url, link))
        # a 2XX code means that we got something
        if f.getcode() / 100 == 2:
            print "OK ", link
        else:
            print "BAD %s (HTTP: %d)" % (link, f.getcode())
    except IOError, msg:
        print "BAD %s (%s)" % (link, msg)

def load_and_check(url):
    title = "Document: %s" % url
    print "\n",title
    print "=" * len(title)
    try:
        links = extract_links(url)
        for link in links:
            check_link(url, link)
    except IOError, msg:
        print "Error: the document could not be retrieved (%s)." % msg
    except HTMLParseError, msg:
        print "Error: the document could not be parsed (%s)." % msg

def linkcheck_main(args=sys.argv[1:]):
    for url in args:
        load_and_check(url)


if __name__ == "__main__":
    linkcheck_main()


